#ifndef __AGUA_H
#define __AGUA_H

#include "atomic.h"


class Agua : public Atomic {
	public:
		//Constructor
		Agua(const string &name = "Agua");

		enum Estado {Normal, AvisandoInicio, EnviandoAgua, AvisandoFin};

	protected:
		//funciones de transicion externa, interna y de output y de inicializacion
		Model& initFunction();
 		Model& externalFunction(const ExternalMessage&); // externa
		Model& internalFunction(const InternalMessage&); // interna
		Model& outputFunction(const CollectMessage&); // salida
		void holdIn(const VTime&); // holdIn sin la fase, ya que es siempre activa

		bool estaPasivo(); // Retorna true si el modelo esta pasivado

	private:
		//puertos de entrada
		const Port &Pedido_in;

		//puertos de salida
		Port &Agua_out;

		//variables de estado
		int Porciones_pedidas;

		int estado;
};


#endif __FICHAS_H
