#ifndef __BEBIDA_H
#define __BEBIDA_H

#include "atomic.h"


class Bebida : public Atomic {
	public:
		//Constructor
		Bebida(const string &name = "Bebida");
		// Estados
		enum Estado {Normal, AvisandoListo, EsperandoAgua, PreparandoBebida, EntregandoBebida};

	protected:
		//funciones de transicion externa, interna y de output y de inicializacion
		Model& initFunction();
 		Model& externalFunction(const ExternalMessage&); // externa
		Model& internalFunction(const InternalMessage&); // interna
		Model& outputFunction(const CollectMessage&); // salida
		void holdIn(const VTime&); // holdIn sin la fase, ya que es siempre activa

		bool estaPasivo(); // Retorna true si el modelo esta pasivado

	private:
		//puertos de entrada
		const Port &Pedido_in;
		const Port &Agua_in;

		//puertos de salida
		Port &Bebida_out;
		Port &Notif_out;

		//variables de estado
		Estado estado;
		int BebidaPreparada;
};


#endif __BEBIDA_H
