#ifndef __BOTONERA_H
#define __BOTONERA_H

#include "atomic.h"


class Botonera : public Atomic {
	public:
		//Constructor
		Botonera(const string &name = "Botonera");
		// Estados
		enum Estado {Normal, EnviandoValor};

	protected:
		//funciones de transicion externa, interna y de output y de inicializacion
		Model& initFunction();
 		Model& externalFunction(const ExternalMessage&); // externa
		Model& internalFunction(const InternalMessage&); // interna
		Model& outputFunction(const CollectMessage&); // salida
		void holdIn(const VTime&); // holdIn sin la fase, ya que es siempre activa
		
	private:
		//puertos de entrada
		const Port &Habilita_in;
		const Port &Pedido_in;
		
		//puertos de salida
		const Port &Pedido_out;
		
		//variables de estado
		Estado estado;
		bool Habilitada;
		long ValorPedido;
};


#endif __BOTONERA_H