#ifndef __DISPLAY_H
#define __DISPLAY_H

#include "atomic.h"


class Display : public Atomic {
	public:
		//Constructor
		Display(const string &name = "Display");
		// Estados
		enum Estado {MostrandoMensaje, ActualizandoMensaje};

	protected:
		//funciones de transicion externa, interna y de output y de inicializacion
		Model& initFunction();
 		Model& externalFunction(const ExternalMessage&); // externa
		Model& internalFunction(const InternalMessage&); // interna
		Model& outputFunction(const CollectMessage&); // salida
		void holdIn(const VTime&); // holdIn sin la fase, ya que es siempre activa
		
	private:
		//puertos de entrada
		const Port &Mensaje_in;
		
		//puertos de salida
		const Port &Mensaje_out;
		
		//variables de estado
		Estado estado;
		int Mensaje;

		ofstream *salida;
};


#endif __DISPLAY_H
