#ifndef __FICHAS_H
#define __FICHAS_H

#include "atomic.h"


class Fichas : public Atomic {
	public:
		//Constructor
		Fichas(const string &name = "Fichas");
		// Estados
		enum Estado {Normal, Rechazando, RechazandoXPedidoInterno, AvisandoFicha, AvisandoNoFicha, Comprando};

	protected:
		//funciones de transicion externa, interna y de output y de inicializacion
		Model& initFunction();
 		Model& externalFunction(const ExternalMessage&); // externa
		Model& internalFunction(const InternalMessage&); // interna
		Model& outputFunction(const CollectMessage&); // salida
		void holdIn(const VTime&); // holdIn sin la fase, ya que es siempre activa

		bool estaPasivo(); // Retorna true si el modelo esta pasivado

	private:
		//puertos de entrada
		const Port &Ficha_in;
		const Port &Eject_in;
		const Port &Comprar_in;

		//puertos de salida
		Port &Lista_out;
		Port &Ficha_out;

		//variables de estado
		Estado estado;
		bool FichaAdentro;
};


#endif __FICHAS_H
