#include "Vasos.h"

// Constructor
Vasos::Vasos(const string &name) : Atomic(name),
		PedidoVaso_in(addInputPort("PedidoVaso_in")),
		Vaso_out(addOutputPort("Vaso_out")),
		Notif_out(addOutputPort("Notif_out")) {
}

// Inicializacion
Model& Vasos::initFunction() {
	this->estado = Normal;
	
	return *this;
}

// Funcion de transicion externa
Model& Vasos::externalFunction(const ExternalMessage& msg) {

	if (msg.port() == PedidoVaso_in) {

		if (this->estado == Normal) {
			this->estado = UbicandoVaso;
			VTime v(0, 0, 1, 0);
			holdIn(v);

		} 
	}

	return *this;
}


// Funcion de transicion interna
Model& Vasos::internalFunction(const InternalMessage& msg) {

	switch (this->estado) {
		case UbicandoVaso:
			this->estado = Normal;
			break;
		default:
			break;
	}

	passivate();

	return *this;
}

// Funcion de salida
Model& Vasos::outputFunction(const CollectMessage& msg) {

	cerr << "output @ vaso" << endl;
	switch (this->estado) {
		case UbicandoVaso:
			cerr << "Enviando notif @ vaso" << endl;
			sendOutput(msg.time(), Notif_out, (Value) 1);
			sendOutput(msg.time(), Vaso_out, (Value) 1);
			break;
		default:
			break;
	}

	return *this;
}

// Funcion holdIn propia
void Vasos::holdIn(const VTime& t) {
	Atomic::holdIn(AtomicState::active, t);
}
